
#include <osl.h>

#ifdef CUSTOMER_HW

#include <linux/gpio.h>
//#include <mach/gpio.h>
#include <asm/irq.h>
#include <generated/autoconf.h>
//#include <mach/regs-gpio.h>
//#include <plat/gpio-cfg.h>


#define IMX_GPIO_NR(bank, nr)		    (((bank) - 1) * 32 + (nr))
#define IMX_GPIO_PIN_NUM(gpio)         ((gpio)%32)
#define IMX_GPIO_PORT_NUM(gpio)      ((gpio)/32 +1)
#define WIFI_WL_REG_ON                      IMX_GPIO_NR(4, 24)	//Pls ref "board-mx6q_sabresd.c" -> SABRESD_WIFI_WL_REG_ON
#define WIFI_WL_HOSH_WAKE              IMX_GPIO_NR(4, 25)		//Pls ref "board-mx6q_sabresd.c" -> SABRESD_WIFI_WL_HOST_WAKUP

extern void imx_wifi_mmc_detect(void);
extern int imx_wifi_mmc_safe_detect(int online);
extern void disable_rescan_wifi_mmc(bool on);
extern void wifi_card_detect(void);

struct wifi_platform_data {
	int (*set_power)(bool val);
	int (*set_carddetect)(bool val);
	void *(*mem_prealloc)(int section, unsigned long size);
	int (*get_mac_addr)(unsigned char *buf);
	void *(*get_country_code)(char *ccode);
};

struct resource dhd_wlan_resources = {0};
struct wifi_platform_data dhd_wlan_control = {0};

#ifdef CUSTOMER_OOB
uint bcm_wlan_get_oob_irq(void)
{
	uint host_oob_irq = 0;

	printk("GPIO(WL_HOST_WAKE) = GPIO_%d_%d\n", IMX_GPIO_PORT_NUM(WIFI_WL_HOSH_WAKE),IMX_GPIO_PIN_NUM(WIFI_WL_HOSH_WAKE));
	host_oob_irq = gpio_to_irq(WIFI_WL_HOSH_WAKE);
	gpio_direction_input(WIFI_WL_HOSH_WAKE);
	printk("host_oob_irq: %d \r\n", host_oob_irq);

	return host_oob_irq;
}

uint bcm_wlan_get_oob_irq_flags(void)
{
	uint host_oob_irq_flags = 0;

	host_oob_irq_flags = (IORESOURCE_IRQ | IORESOURCE_IRQ_HIGHLEVEL | IORESOURCE_IRQ_SHAREABLE) & IRQF_TRIGGER_MASK;

	printk("host_oob_irq_flags=%d\n", host_oob_irq_flags);

	return host_oob_irq_flags;
}
#endif

int bcm_wlan_set_power(bool on)
{
	int err = 0;

	if (on) {
		printk("======== PULL WL_REG_ON HIGH! ========\n");

		gpio_set_value(WIFI_WL_REG_ON, 1);

		/* Lets customer power to get stable */
		mdelay(100);
        printk("======== Card detection to detect SDIO card ========\n");
        wifi_card_detect;
	} else {
		printk("======== PULL WL_REG_ON LOW! ========\n");

		gpio_set_value(WIFI_WL_REG_ON, 0);
		mdelay(100);
	}

	return err;
}

int bcm_wlan_set_carddetect(bool present)
{
	int err = 0;
    return err;
	if (present) {
		printk("======== Card detection to detect SDIO card! ========\n");
		mdelay(100);
		//err=imx_wifi_mmc_safe_detect(1);
		mdelay(100);
		//err = sdhci_s3c_force_presence_change(&sdmmc_channel, 1);
	} else {
		printk("======== Card detection to remove SDIO card! ========\n");
		mdelay(100);
		//err=imx_wifi_mmc_safe_detect(0);
		mdelay(100);
		//err = sdhci_s3c_force_presence_change(&sdmmc_channel, 0);
	}

	return err;
}

#ifdef CONFIG_DHD_USE_STATIC_BUF
extern void *bcmdhd_mem_prealloc(int section, unsigned long size);
void* bcm_wlan_prealloc(int section, unsigned long size)
{
	void *alloc_ptr = NULL;
	alloc_ptr = bcmdhd_mem_prealloc(section, size);
	if (alloc_ptr) {
		printk("success alloc section %d, size %ld\n", section, size);
		if (size != 0L)
			bzero(alloc_ptr, size);
		return alloc_ptr;
	}
	printk("can't alloc section %d\n", section);
	return NULL;
}
#endif

int bcm_wlan_set_plat_data(void) {
	printk("======== %s ========\n", __FUNCTION__);
	dhd_wlan_control.set_power = bcm_wlan_set_power;
	dhd_wlan_control.set_carddetect = bcm_wlan_set_carddetect;
#ifdef CONFIG_DHD_USE_STATIC_BUF
	dhd_wlan_control.mem_prealloc = bcm_wlan_prealloc;
#endif
	return 0;
}

#endif /* CUSTOMER_HW */
